// ASSEMBLY tells compiler to use the assembly version of the event handler.
// It MUST be defined before the header files or non-assembly code will
// be used that may be model-dependent.
// Whether or not the code is assembly dependent is transparent to
// this module.
// mouse.h should not be included if handler.h is, due to the dependency
// structure of handler.h, which includes mouse.h

#define ASSEMBLY

#include <stdio.h>
#include <conio.h>
#include "handler.h"

main()
{
  clrscr();
  gotoxy(27,1);
  puts("Mouse event handling demo");
  gotoxy(17,24);
  puts("Press left button for position, right to quit");
  gotoxy(1,1);

  mouse maus;

  event_setup();

  if(maus.installed())
  {
    maus.install_task(0x14,FP_SEG(handler),FP_OFF(handler));
    me->reset();
    maus.show();

    do {
      if (me->event==4) {
	maus.hide();
	printf("\nx=%3d,\ty=%3d",me->x,me->y);
	maus.show();
	me->reset();
      }
    } while (me->event!=0x10);
    
    maus.hide();
    maus.reset();
  }
  clrscr();
}