#define ASSEMBLY

//Declare these first to avoid recompilation of headers if assembly code
//is used in the handler -- Time saver

#include <stdio.h>
#include <dos.h>
#include <graphics.h>

#include "handler.h"
#include "gmcur.h"

#ifndef TRUE
#define TRUE -1
#define FALSE 0
#endif

#define EVENTMASK 0x55	//any button released or mouse moved
#define menu		20	//bottom of menu area
#define help_top	185	//top of help area
#define box1		160	//right of each menu box
#define box2		320
#define box3		480
#define message1	"Click a button to begin drawing"
#define message2	"Hold down left button to begin drawing"

mouse maus;

void menu_box(int, int, char *);
void help(char *);
int setup();
void update_meter(int, int);
void work();

void main()
{
  initcurs();
  event_setup();

  if(maus.installed())
  {
    if (setup())
    {
      maus.install_task(EVENTMASK,FP_SEG(handler),FP_OFF(handler));
      maus.graph_cursor(hand.hot_x,hand.hot_y,_DS,(unsigned)hand.image);
      maus.yrange(0,help_top);
      maus.show();
      maus.getpos();
      update_meter(maus.x(),maus.y());
      work();
      closegraph();
    }
    else puts("Graphics mode not available.");
  }
  else puts("Mouse inactive. Check installation.");
}

void menu_box(int x1, int x2, char *item)
{
  setviewport(x1+1,1,x2-1,menu-1,FALSE);
  clearviewport();
  outtextxy(50,7,item);
  setviewport(0,0,getmaxx(),getmaxy(),FALSE);
}

void help(char *message)
{
  int x=(getmaxx()-textwidth(message))/2;
  setviewport(1,help_top+1,638,getmaxy()-1,FALSE);
  clearviewport();
  outtextxy(x,3,message);
  setviewport(0,menu,639,help_top,FALSE);
}

int setup()
{
  int   driver = CGA, mode = CGAHI;
  char path[]="C:\\TC\\BGI";

  initgraph(&driver,&mode,path);
  if (graphresult()==grOk) {
    setcolor(1);
    settextstyle(DEFAULT_FONT,HORIZ_DIR,1);
    menu_box(0,box1,"Scribble");
    rectangle(0,0,box1,menu);
    menu_box(box1,box2,"Clear");
    rectangle(box1,0,box2,menu);
    menu_box(box2,box3,"Quit");
    rectangle(box2,0,box3,menu);
    rectangle(box3,0,639,menu);
    rectangle(0,help_top,639,getmaxy());
    help(message1);
    return TRUE;
  }
  else return FALSE;
}

void update_meter(int x, int y)
{
  char position[9];
  sprintf(position,"%3d, %3d",x,y);
  menu_box(box3,639,position);
}

void work()
{
  int thru=FALSE,pen=FALSE;
  do {
    me->reset();
    while(me->event==0);
    switch(me->event) {
      case 0x00001:	//mouse moved
	if ((me->y > menu) && (me->event < help_top)) {
	  if (pen) {
	    maus.hide();
	    putpixel(me->x,me->y,1);
	    maus.show();
	  }
	}
	update_meter(me->x,me->y);
	break;
      case 0x0004:
      case 0x0010:
      case 0x0040:
	if (me->y<menu)
	  if (me->x<box1) {
	    maus.graph_cursor(cross.hot_x,cross.hot_y,_DS,
			     (unsigned) cross.image);
	    pen=TRUE;
	    help(message2);
	  }
	else
	  if (me->x<box2) {
	    maus.hide();
	    setviewport(0,menu+1,getmaxx(),help_top-1,TRUE);
	    clearviewport();
	    maus.show();
	    maus.graph_cursor(hand.hot_x,hand.hot_y,_DS,
			     (unsigned)hand.image);
	    pen=FALSE;
	    help(message1);
	  }
	  else if (me->x<box3) thru=TRUE;
    }
  } while (!thru);
}